searchNodes=[{"doc":"Uinta is a plugin for the default Elixir logger that lowers log volume while maximizing log usefulness. It is not a logger backend, but rather includes Uinta.Formatter which will format logs on top of the default Elixir logger backend. In addition to the formatter, Uinta also includes Uinta.Plug. The plug is a drop-in replacement for Plug.Logger that will log out the request and response on a single line. It can also put the request info into the top-level JSON for easier parsing by your log aggregator. Installation The formatter and plug will be installed separately depending on the functionality that you want. To install the formatter, see the instructions in Uinta.Formatter To install the plug, see the instructions in Uinta.Plug","ref":"Uinta.html","title":"Uinta","type":"module"},{"doc":"The Uinta Formatter will wrap normal log statements in a JSON object. The log level, timestamp, and metadata will all be attached to it as parts of the object. The formatter can also format stuctured log messages. When a JSON string is received for formatting, it will be decoded and merged with the map to be output. In this way any keys that are passed to it will be on the high level object, so that they won&#39;t need to be extracted from a secondary object later on. JSON tends to be a great solution for making logs easily machine parseable, while still being mostly human readable. However, it is recommended that if you have separate configuration for development and production environments that you only enable this in the production environment as it can still decrease developer productivity to have to mentally parse JSON during development. Installation To use the formatter, you&#39;ll need to add it to your logger configuration. In your (production) config file, see if you have a line that looks something like this: config :logger, :console, format: &quot;[$level] $message\\n&quot; If you have it, you&#39;ll want to replace it with this: config :logger, :console, format: {Uinta.Formatter, :format} If you don&#39;t have it, you&#39;ll want to just add that line.","ref":"Uinta.Formatter.html","title":"Uinta.Formatter","type":"module"},{"doc":"This function takes in four arguments, as defined by Logger: level is the log level, one of :debug, :info, :warn, and :error message is the message to be formatted. This should be iodata (typically String or iolist) timestamp is a timestamp formatted according to Logger.Formatter.time/0 metadata is a keyword list containing metadata that will be included with the log line However, this line should not be called manually. Instead it should be called by configuring the Elixir logger in your project to use it as a custom log formatter. See the installation instructions for more information.","ref":"Uinta.Formatter.html#format/4","title":"Uinta.Formatter.format/4","type":"function"},{"doc":"","ref":"Uinta.Formatter.html#t:level/0","title":"Uinta.Formatter.level/0","type":"type"},{"doc":"","ref":"Uinta.Formatter.html#t:time/0","title":"Uinta.Formatter.time/0","type":"type"},{"doc":"This plug combines the request and response logs into a single line. This brings many benefits including: Removing the need to visually match up the request and response makes it easier to read your logs and get a full picture of what has happened. Having a single line for both request and response halves the number of request logs that your log aggregator will need to process and index, which leads to saved costs In addition to combining the log lines, it also gives you the ability to output request logs in JSON format so that you can easily have your log aggregator parse the fields. To do this, pass json: true in the options when calling the plug. Finally, GraphQL requests will replace POST /graphql with the GraphQL operation type and name like QUERY getUser or MUTATION createUser if an operation name is provided. This will give you more visibility into your GraphQL requests without having to log out the entire request body or go into debug mode. If desired, the GraphQL variables can be included in the log line as well. The query can also be included if unnamed. Installation To install this, find this line (typically in YourApp.Endpoint): plug Plug.Logger and replace it with this (using only the options you want): plug Uinta.Plug, log: :info, json: false, include_variables: false, filter_variables: [] Options :log - The log level at which this plug should log its request info. Default is :info :json - Whether or not this plug should log in JSON format. Default is false :include_variables - Whether or not to include any GraphQL variables in the log line when applicable. Default is false. :filter_variables - A list of variable names that should be filtered out from the logs. By default password, passwordConfirmation, idToken, and refreshToken will be filtered. :include_unnamed_queries - Whether or not to include the full query body for queries with no name supplied","ref":"Uinta.Plug.html","title":"Uinta.Plug","type":"module"},{"doc":"","ref":"Uinta.Plug.html#t:format/0","title":"Uinta.Plug.format/0","type":"type"},{"doc":"","ref":"Uinta.Plug.html#t:graphql_info/0","title":"Uinta.Plug.graphql_info/0","type":"type"},{"doc":"","ref":"Uinta.Plug.html#t:opts/0","title":"Uinta.Plug.opts/0","type":"type"}]